package com.eactive.eai.batch.job.jobItem.cfa;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

import com.eactive.eai.batch.common.FileUtil;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_CFABT_0200 extends DefaultTelegram implements TelegramService
{

    private FileInputStream fin ;
    private File file;
    private int SEQUENCE_NO;
    private int REC_CNT;
    private int REAL_BYTE;      // 실 data byte수
    private int SEND_LENGTH;        //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    private Properties jobInfo;
    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_CFABT_0200() {
        //DATA전문
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = makeSendData();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //TR - CODE 
        	compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

        	//TEXT 개시문자
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //전문종별코드 - 전문의 기능을 나타내는 4Bytes 코드로 구성
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //업무구분코드
            compileField(4, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[4]);
            
            //전문개시일시
            compileField(5, TelegramKeys.getYYYYMMddHHmmss().substring(2), this.al_FieldProps[5]);

            //전문추적번호
            compileField(6, makeZero("", ((byte[]) this.al_Field.get(6)).length), this.al_FieldProps[6]);

            //거래구분코드 - 전문발생기관에서 전문을 구분하기 위하여 부여되는 코드로 한 거래가 끝날때까지 코드가 바뀌지 않고 SET 되어져야 한다.
            //            - 수신기관 CODE(2) : 수신기관에 해당하는 CODE를 기록한다. (기관 CODE CHECK)
            //            - 발신기관 CODE(2) : 발신기관에 해당하는 CODE를 기록한다. (기관 CODE CHECK)
            //            - 발신 단말 번호(8)
            //            - 블록 건수       (6)
            String txnGbnCd = "00" + telegramInfo.getProperty(TelegramKeys.BANK_CODE) +
                              makeZero("", ((byte[]) this.al_Field.get(7)).length - 4 ) ;
            compileField(7, txnGbnCd, this.al_FieldProps[7]);
            
            //BLOCK 건수 - 데이터 전문 전송 횟수를 set함.
            compileField(8, makeZero("" + SEQUENCE_NO, ((byte[]) this.al_Field.get(8)).length), this.al_FieldProps[8]);
            
            //자료건수 - 한 전문내에 SET할 수 있는 해당 업무별 RECORD의 갯수이며 전문 송신시 실 RECORD의 수를 SET함.
            compileField(9, makeZero( ""+ REC_CNT, ((byte[]) this.al_Field.get(9)).length), this.al_FieldProps[9]);
            
            //자료계속 여부 - 향후 사용
            compileField(10, makeZero("", ((byte[]) this.al_Field.get(10)).length), this.al_FieldProps[10]);

            //망 관리정보 - 협회와 신용카드업자간의 시스템 상태에 대한 정보코드로 아래 값 중  하나를 SET 한다
            // 001 - 개시
            // 002 - 재개시
            // 003 - 종료예고
            // 004 - 종료
            // 005 - SYSTEM BUSY
            // 006 - SYSTEM BUSY 회복
            // 007 - SYSTEM 장애
            // 008 - SYSTEM 장애 회복
            // 301 - 상태확인 처리
            compileField(11, this.getFldOpCode(), this.al_FieldProps[11]);
            
            //응답코드 - 전문의 처리결과를 정의해주는 코드로 다음의 응답코드를 기록한다.
            compileField(12, makeZero("", ((byte[]) this.al_Field.get(12)).length), this.al_FieldProps[12]);
            
            // FILLER
            compileField(13, "", this.al_FieldProps[13]);
            //<< 전문 완성

            
//            //전문일련번호 - 전송 Data중 최초 Data 순서번호 또는 재개시, 거부응답의  경우에는 정상처리의 최종 Data번호
//            compileField(7, "" + SEQUENCE_NO, this.al_FieldProps[7]);
//            
//            //DATA건수 - 데이터블록내의 전송 Data 건수
//            compileField(8, "" + REC_CNT, this.al_FieldProps[8]);
//            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }
    
    public int getInformalFieldSendData(int idx, byte[] data) {
    	int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            
            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);
            // 20060419 add by khs for 전송상태 확인
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + (REC_CNT*batchDoc.getBatchMsg().getHeader().getRecLen());
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            // 로깅을 위해 
//            byte[] fieldData = new byte[fldLen];
//            System.arraycopy(data, 0, fieldData, 0, fldLen);
//            this.al_Field.set( idx, fieldData);
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

			if ( file != null ){ // 처음 전송이면

				//DB로그에 남길 파일 헤더,트레일러 내용 설정
				super.setFileHeaderAndTrailer(file);
				//요구송신 파일 Start DB로그
//	    		batchDoc.getBatchMsg().getHeader().setFileSize(file.length());
    			LogUtil.setLogFileStart(batchDoc);
			}
//            if ( this.getOpCode().equals("000") ){ // DATA전송인 경우
//    			this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO + REC_CNT - 1);
//            }
//            logger.debug("[파일사이즈]->" + batchDoc.getBatchMsg().getHeader().getFileSize() + ", 현재 크기-->" + batchDoc.getBatchMsg().getBody().getCurFileSize());
            long totalFileSize = batchDoc.getBatchMsg().getHeader().getFileSize();
            long curFileSize = batchDoc.getBatchMsg().getBody().getCurFileSize();
            if ( curFileSize >= totalFileSize){
            	LogUtil.setLogFileEnd(batchDoc);
            }
            batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<14; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
//            batchDoc.getBatchMsg().setTelegramBody(new String((byte[])this.al_Field.get(14)));
            batchDoc.getBatchMsg().setTelegramBody("");

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            jobInfo      = getJobInfo();
            SEQUENCE_NO = batchDoc.getBatchMsg().getBody().getSeqNum() + 1;
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }
    
    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

    	if (idx >= this.getFieldCount()) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
		return REAL_BYTE;

    }

    private boolean createFile ()
    {
    	fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID() );
    	
    	if ( fin == null ){
            try {
                String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
                String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

                if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                    fileDir = fileDir + File.separator;
                }

                String fileName = fileDir + fileNm;

                file = new File(fileName);
                if (!file.exists()) // 파일이 없으면 리턴 False
                {
                    String[] msgArgs = new String[2];
                    msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                    msgArgs[1] = fileName;
                    String errCode = "BECEAIFJI022";
                    String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                    this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                    throw new Exception(" the File["+fileName+"] does not exist!!!");
                }
                fin = new FileInputStream(file);
                BatchOpenFileManager.getInstance().addFile(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, fin);
            } catch (Exception e) {
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI028";
                String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.error( e.getMessage(), e);
            }    	
    	}
    	return !( fin == null);
    }

    private boolean makeSendData()
    {
    	try {
            if (!createFile()) {
            	logger.error("{}  file open failed", logHeader);
                return false;
            }

//            byte[] fileLine = null;
//
//            if ( retryCnt > 0 ){  // 타임오버 이후의 재 전송인 경우, 이전에 DATA가 있었던 경우에만
//            	
//            	if ( batchDoc.getBatchMsg().getTelegramBody() != null && !batchDoc.getBatchMsg().getTelegramBody().equals("") ){
//                	logger.debug("batchDoc.getEAIBatchMessage().getTelegramBody()-->[" + batchDoc.getBatchMsg().getTelegramBody() + "]");
//            		byte[] prevData = batchDoc.getBatchMsg().getTelegramBody().getBytes();
//                	fileLine = new byte[prevData.length + 2];
//                	System.arraycopy( batchDoc.getBatchMsg().getTelegramHeader().getBytes(), 47, fileLine, 0, 2);
//                	System.arraycopy(prevData, 0, fileLine, 2, prevData.length);
//            	}
//            }else{
//            	if ( isReSend ){ // 중단된 이후 재 송신인 경우
//            		fileLine = skipLine();
//            	}else{
//                	fileLine = FileUtil.readLine(fin);
//            	}
//            }

            // 한번에 블러킹 할 건수
            int seqCnt = 1;
            int padLen = 0;
        	try {
        		seqCnt = Integer.parseInt(jobInfo.getProperty(TelegramKeys.BLOCKING_COUNT));
        		padLen = Integer.parseInt(jobInfo.getProperty(TelegramKeys.PADDING_LEN));
        	} catch (Exception e) {}

            	
			logger.debug("[SEND_CFABT_0200]SEQUENCE_NO-->" + SEQUENCE_NO + ",seqCnt-->" + seqCnt);
            // 남은 바이트 수
            long remainSize = batchDoc.getBatchMsg().getHeader().getFileSize() - batchDoc.getBatchMsg().getBody().getCurFileSize();
            logger.debug("[SEND_CFABT_0200]batchDoc.getBatchMsg().getHeader().getFileSize()-->" + batchDoc.getBatchMsg().getHeader().getFileSize());
            logger.debug("[SEND_CFABT_0200]batchDoc.getBatchMsg().getBody().getCurFileSize()-->" + batchDoc.getBatchMsg().getBody().getCurFileSize());
            logger.debug("[SEND_CFABT_0200]remainSize-->" + remainSize);
            // 남은 건수
            long remainCnt = remainSize / batchDoc.getBatchMsg().getHeader().getRecLen();
            logger.debug("[SEND_CFABT_0200]remainCnt-->" + remainCnt);
            
            boolean isLastSeq = false;
            REC_CNT = seqCnt;
            if ( remainCnt < seqCnt ){
            	REC_CNT = (int)remainCnt;
            	isLastSeq = true;
            }
            logger.debug("[SEND_CFABT_0200]readCnt-->" + REC_CNT);

            REAL_BYTE = batchDoc.getBatchMsg().getHeader().getRecLen() * seqCnt + padLen;
            
            logger.debug("[SEND_CFABT_0200]REAL_BYTE-->" + REAL_BYTE);
            
            fileData = new byte[REAL_BYTE];
            for (int inx = 0; inx < fileData.length; inx++) {
            	fileData[inx] = ' ';
			} 
            for ( int inx = 0 ; inx < REC_CNT ; inx++){
                byte[] fileLine = FileUtil.readLine(fin);
                System.arraycopy( fileLine, 0, fileData, inx * batchDoc.getBatchMsg().getHeader().getRecLen(), batchDoc.getBatchMsg().getHeader().getRecLen());
            }
            
            if ( isLastSeq ){
            	fin.close();
            	BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID());
            }

//            
//            fileLine = FileUtil.readLine(fin);
//
//            if ( fileLine != null ){
//                byte[] byte_cnt = new byte[2];
//                byte[] byte_first_seq = new byte[8];
//                //logger.debug( "makeSendData:fileLine-->" + new String(fileLine ));
//                System.arraycopy( fileLine, 0, byte_cnt, 0, 2);
//                System.arraycopy( fileLine, 2, byte_first_seq, 0, 8);
//                REC_CNT = Integer.parseInt( new String(byte_cnt));
//                SEQUENCE_NO = Integer.parseInt( new String(byte_first_seq));
//                REAL_BYTE = REC_CNT * batchDoc.getBatchMsg().getHeader().getRecLen();
//                fileData = new byte[REAL_BYTE];
//                System.arraycopy( fileLine, 2, fileData, 0, REAL_BYTE);
//                
//            }else{
//            	REAL_BYTE = 0;
//            	this.setFldOpCode("999");
//            	SEQUENCE_NO = batchDoc.getBatchMsg().getBody().getSeqNum();
//            	fin.close();
//            	BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID() );
//            	
//            }

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }
    
//    private byte[] skipLine() throws Exception{
//    	byte[] fileLine = null;
//		byte[] byte_count = new byte[2];
//		byte[] byte_sequence = new byte[8];
//		int iCount = 0;
//		int iSequence = 0;
//		int skipCnt = 0;  // 읽은 라인에서 스킵할 건수
//    	while ( ( fileLine = FileUtil.readLine(fin) ) != null ){
//    		System.arraycopy( fileLine, 0, byte_count, 0, 2);
//    		System.arraycopy(fileLine, 2, byte_sequence, 0, 8);
//    		iCount = Integer.parseInt( new String(byte_count));
//    		iSequence = Integer.parseInt( new String(byte_sequence));
//    	    if ( LAST_SEQ + 1 <= iSequence+iCount -1 ){
//    	    	//logger.debug("skipLine:LAST_SEQ->" + LAST_SEQ);
//    	    	
//    	    	skipCnt = LAST_SEQ + 1 - iSequence;
//    	    	int skipByte = skipCnt * batchDoc.getBatchMsg().getHeader().getRecLen();
//    	    	byte []newFileLine = new byte[fileLine.length - skipByte];
//    	    	if ( iCount - skipCnt < 10 ){
//    	    		newFileLine[0] = '0';
//    	    		newFileLine[1] = (""+(iCount - skipCnt)).getBytes()[0];
//    	    	}else{
//    	    		System.arraycopy((""+(iCount - skipCnt)).getBytes(), 0, newFileLine, 0, 2);
//    	    	}
//    	    	System.arraycopy(fileLine, 2 + skipByte, newFileLine, 2, newFileLine.length -2);
//    	    	return newFileLine;
//    	    }
//    	}
//    	throw new Exception("재전송 시작할 위치를 찾지 못하였습니다.");
//    }

    private boolean calculateSendLength () {
        try {
        	for (int i=1; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += REAL_BYTE;
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(12);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getFieldValueString(11);
    }
}

